import com.urbancode.air.XTrustProvider;
import com.urbancode.plugin.servicenow.changerequest.ServiceNow_change_requestStub;
import com.urbancode.plugin.servicenow.changerequest.ServiceNow_change_requestStub.Get;
import com.urbancode.plugin.servicenow.changerequest.ServiceNow_change_requestStub.GetResponse;
import com.urbancode.plugin.servicenow.changerequest.ServiceNow_change_requestStub.GetKeys;
import com.urbancode.plugin.servicenow.changerequest.ServiceNow_change_requestStub.GetKeysResponse;
import org.apache.axis2.transport.http.HttpTransportProperties;
import org.apache.axis2.transport.http.HttpTransportProperties.Authenticator;

final def props = new Properties();
final def inputPropsFile = new File(args[0]);
final def inputPropsStream = null;
try {
    inputPropsStream = new FileInputStream(inputPropsFile);
    props.load(inputPropsStream);
}
catch (IOException e) {
    throw new RuntimeException(e);
}

XTrustProvider.install();

def serverUrl = props['serverUrl'];
def username = props['username'];
def password = props['passwordScript']?props['passwordScript']:props['password'];
def changeRequestId = props['changeRequestId'];
def status = props['status'];

if (serverUrl.startsWith("https://")) {
    serverUrl = serverUrl.substring(8);
}

if (serverUrl.startsWith("http://")) {
    serverUrl = serverUrl.substring(7);
}

while (serverUrl.endsWith("/")) {
    serverUrl = serverUrl.substring(0, serverUrl.length() - 1);
}

serverUrl = "https://" + serverUrl + "/change_request.do?SOAP";


HttpTransportProperties.Authenticator basicAuth = new HttpTransportProperties.Authenticator();
println "Using serverUrl ${serverUrl}";
println "Using username ${username}";
println "Using password ${password}";
println "Checking request with number ${changeRequestId}";
println "Checking for status ${status}";
basicAuth.setUsername(username);
basicAuth.setPassword(password);

ServiceNow_change_requestStub stub = new ServiceNow_change_requestStub(serverUrl);
stub._getServiceClient().getOptions().setProperty(org.apache.axis2.transport.http.HTTPConstants.CHUNKED, Boolean.FALSE);
stub._getServiceClient().getOptions().setProperty(org.apache.axis2.transport.http.HTTPConstants.AUTHENTICATE, basicAuth);

ServiceNow_change_requestStub.GetKeys keyGetter = new ServiceNow_change_requestStub.GetKeys();
keyGetter.setNumber(changeRequestId);

ServiceNow_change_requestStub.GetKeysResponse keyResp = null;
try {
    keyResp = stub.getKeys(keyGetter);
}
catch (Exception e) {
    e.printStackTrace();
    throw e;
}

if (Integer.valueOf(keyResp.getCount()) > 1) {
    throw new Exception("found more than one, ${keyResp.getCount()}, change request with number ${changeRequestId}!");
}
else if (Integer.valueOf(keyResp.getCount()) == 0) {
    throw new Exception("Found no change requests with number ${changeRequestId}!");
}

String actualChangeRequestId = keyResp.getSys_id()[0];



ServiceNow_change_requestStub.Get getter = new ServiceNow_change_requestStub.Get();
getter.setSys_id(actualChangeRequestId);

ServiceNow_change_requestStub.GetResponse resp = null;
try {
    resp = stub.get(getter);
}
catch (Exception e) {
    e.printStackTrace();
    throw e;
}

if (resp == null) {
    throw new Exception("Change request not found to check approval status!");
}

Integer reportedStatus = resp.getState().intValue();
if (reportedStatus != Integer.valueOf(status)) {
    throw new Exception("Reported status, ${reportedStatus}, not equal to ${status}!");
}

println "Reported approval status matches requested status, ${status}!";
System.exit(0);
