import com.urbancode.air.XTrustProvider;
import com.urbancode.plugin.servicenow.changerequest.ServiceNow_change_requestStub;
import com.urbancode.plugin.servicenow.changerequest.ServiceNow_change_requestStub.Get;
import com.urbancode.plugin.servicenow.changerequest.ServiceNow_change_requestStub.GetResponse;
import com.urbancode.plugin.servicenow.changerequest.ServiceNow_change_requestStub.GetKeys;
import com.urbancode.plugin.servicenow.changerequest.ServiceNow_change_requestStub.GetKeysResponse;
import com.urbancode.plugin.servicenow.changetask.ServiceNow_change_taskStub;
import com.urbancode.plugin.servicenow.changetask.ServiceNow_change_taskStub.Get;
import com.urbancode.plugin.servicenow.changetask.ServiceNow_change_taskStub.GetResponse;
import com.urbancode.plugin.servicenow.changetask.ServiceNow_change_taskStub.GetKeys;
import com.urbancode.plugin.servicenow.changetask.ServiceNow_change_taskStub.GetKeysResponse;
import org.apache.axis2.transport.http.HttpTransportProperties;
import org.apache.axis2.transport.http.HttpTransportProperties.Authenticator;

final def props = new Properties();
final def inputPropsFile = new File(args[0]);
final def inputPropsStream = null;
try {
    inputPropsStream = new FileInputStream(inputPropsFile);
    props.load(inputPropsStream);
}
catch (IOException e) {
    throw new RuntimeException(e);
}
finally {
    inputPropsStream.close()
}

XTrustProvider.install();

def serverUrl = props['serverUrl'];
def username = props['username'];
def password = props['passwordScript']?props['passwordScript']:props['password'];
def tasksIds = props['tasksId'];
def status = props['status'];

if (serverUrl.startsWith("https://")) {
    serverUrl = serverUrl.substring(8);
}

if (serverUrl.startsWith("http://")) {
    serverUrl = serverUrl.substring(7);
}

while (serverUrl.endsWith("/")) {
    serverUrl = serverUrl.substring(0, serverUrl.length() - 1);
}

def taskServerUrl = "https://" + serverUrl + "/change_task.do?SOAP";


HttpTransportProperties.Authenticator basicAuth = new HttpTransportProperties.Authenticator();
println "Using serverUrl ${serverUrl}";
println "Using username ${username}";
println "Using password ${password}";
println "Updating task Ids with number ${tasksIds}";
println "Updating with status ${status}";
basicAuth.setUsername(username);
basicAuth.setPassword(password);

ServiceNow_change_taskStub taskStub = new ServiceNow_change_taskStub(taskServerUrl);
taskStub._getServiceClient().getOptions().setProperty(org.apache.axis2.transport.http.HTTPConstants.CHUNKED, Boolean.FALSE);
taskStub._getServiceClient().getOptions().setProperty(org.apache.axis2.transport.http.HTTPConstants.AUTHENTICATE, basicAuth);

String tasks = tasksIds;

tasks.split(',').each { taskId ->
    println ""
    //for each task check status report bad ones
    if (!taskId || taskId.trim() == "") {
        return;
    }
    println "Updating Task ${taskId}";
    ServiceNow_change_taskStub.Update taskUpdater = new ServiceNow_change_taskStub.Update();
    taskUpdater.setSys_id(taskId);
    taskUpdater.setState(new BigInteger(status));
    
    ServiceNow_change_taskStub.UpdateResponse taskResp = new ServiceNow_change_taskStub.UpdateResponse();
    try {
        taskResp = taskStub.update(taskUpdater);
    }
    catch (Exception e) {
        e.printStackTrace();
        throw e;
    }

    if (taskResp == null) {
       throw new Exception("Failed to update task state!");
    }
}

println ""
println "**********************************************************************************";
println ""

println "All task statuses updated to ${status}!";
System.exit(0);
